> For the complete documentation index, see [llms.txt](https://docs.mediarithmics.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mediarithmics.io/api-reference/plugin/plugins.md).

# Plugins

Operations related to **Plugins**, the extensible web service components hosted by the platform that add custom functionality. Plugin types include:

* **Activity Analyzers** (enrich tracking data)
* **Audience Segment External Feeds** (sync segments to partners)
* **Display Ad Renderers** (customize ad rendering)
* **Email Renderers** (customize email rendering)
* **Email Routers** (manage email sending)
* **Attribution Engines** (custom attribution)
* **Custom Actions** (automation actions)
* **ML Algorithms** (predictions)
* **Computed Fields** (calculated schema fields)

Relevant documentation:

* [Plugins](https://developer.mediarithmics.io/advanced-usages/plugins)

## GET /plugins/{plugin\_id}/versions/{plugin\_version\_id}/configuration\_file/technical\_name={technical\_name}

> Get a Plugin Version Configuration file

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Plugins","description":"Operations related to **Plugins**, the extensible web service components hosted by the platform that add custom functionality. Plugin types include:\n- **Activity Analyzers** (enrich tracking data)\n- **Audience Segment External Feeds** (sync segments to partners)\n- **Display Ad Renderers** (customize ad rendering)\n- **Email Renderers** (customize email rendering)\n- **Email Routers** (manage email sending)\n- **Attribution Engines** (custom attribution)\n- **Custom Actions** (automation actions)\n- **ML Algorithms** (predictions)\n- **Computed Fields** (calculated schema fields)\n\nRelevant documentation:\n- [Plugins](https://developer.mediarithmics.io/advanced-usages/plugins)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/plugins/{plugin_id}/versions/{plugin_version_id}/configuration_file/technical_name={technical_name}":{"get":{"responses":{"200":{"description":"Success !","content":{"application/octet-stream":{"schema":{"type":"string","format":"binary"}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"parameters":[{"in":"path","style":"simple","schema":{"type":"string"},"description":"ID of the plugin","explode":false,"name":"plugin_id","required":true},{"explode":false,"required":true,"description":"ID of the plugin version","name":"plugin_version_id","in":"path","style":"simple","schema":{"type":"string"}},{"style":"simple","schema":{"type":"string"},"required":true,"description":"technical name of the Plugin Version Configuration","in":"path","name":"technical_name","explode":false}],"tags":["Plugins"],"description":"","operationId":"fetchConfigurationFile","summary":"Get a Plugin Version Configuration file"}}},"components":{"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}},"schemas":{"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}}}}
```

## PUT /plugins/{plugin\_id}/versions/{plugin\_version\_id}/configuration\_file/technical\_name={technical\_name}

> Put a Plugin Version Configuration file

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Plugins","description":"Operations related to **Plugins**, the extensible web service components hosted by the platform that add custom functionality. Plugin types include:\n- **Activity Analyzers** (enrich tracking data)\n- **Audience Segment External Feeds** (sync segments to partners)\n- **Display Ad Renderers** (customize ad rendering)\n- **Email Renderers** (customize email rendering)\n- **Email Routers** (manage email sending)\n- **Attribution Engines** (custom attribution)\n- **Custom Actions** (automation actions)\n- **ML Algorithms** (predictions)\n- **Computed Fields** (calculated schema fields)\n\nRelevant documentation:\n- [Plugins](https://developer.mediarithmics.io/advanced-usages/plugins)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/plugins/{plugin_id}/versions/{plugin_version_id}/configuration_file/technical_name={technical_name}":{"put":{"description":"","operationId":"putConfigurationFile","responses":{"200":{"$ref":"#/components/responses/simple"},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"tags":["Plugins"],"requestBody":{"description":"The file delivery destination credentials to update","content":{"application/octet-stream":{"schema":{"type":"string","format":"binary"}}},"required":true},"summary":"Put a Plugin Version Configuration file","parameters":[{"schema":{"type":"string"},"explode":false,"in":"path","name":"plugin_id","required":true,"style":"simple","description":"ID of the plugin"},{"in":"path","name":"plugin_version_id","explode":false,"schema":{"type":"string"},"style":"simple","required":true,"description":"ID of the plugin version"},{"schema":{"type":"string"},"name":"technical_name","style":"simple","in":"path","description":"technical name of the Plugin Version Configuration","explode":false,"required":true}]}}},"components":{"responses":{"simple":{"description":"Success response","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]}},"required":["status"]}}}},"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}},"schemas":{"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}}}}
```

## DELETE /plugins/{plugin\_id}/versions/{plugin\_version\_id}/configuration\_file/technical\_name={technical\_name}

> Delete a Plugin Version Configuration file

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Plugins","description":"Operations related to **Plugins**, the extensible web service components hosted by the platform that add custom functionality. Plugin types include:\n- **Activity Analyzers** (enrich tracking data)\n- **Audience Segment External Feeds** (sync segments to partners)\n- **Display Ad Renderers** (customize ad rendering)\n- **Email Renderers** (customize email rendering)\n- **Email Routers** (manage email sending)\n- **Attribution Engines** (custom attribution)\n- **Custom Actions** (automation actions)\n- **ML Algorithms** (predictions)\n- **Computed Fields** (calculated schema fields)\n\nRelevant documentation:\n- [Plugins](https://developer.mediarithmics.io/advanced-usages/plugins)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/plugins/{plugin_id}/versions/{plugin_version_id}/configuration_file/technical_name={technical_name}":{"delete":{"operationId":"deleteConfigurationFile","responses":{"200":{"$ref":"#/components/responses/simple"},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"description":"","summary":"Delete a Plugin Version Configuration file","parameters":[{"style":"simple","name":"plugin_id","in":"path","description":"ID of the plugin","explode":false,"schema":{"type":"string"},"required":true},{"schema":{"type":"string"},"style":"simple","name":"plugin_version_id","description":"ID of the plugin version","explode":false,"required":true,"in":"path"},{"schema":{"type":"string"},"explode":false,"name":"technical_name","style":"simple","in":"path","required":true,"description":"technical name of the Plugin Version Configuration"}],"tags":["Plugins"]}}},"components":{"responses":{"simple":{"description":"Success response","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]}},"required":["status"]}}}},"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}},"schemas":{"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}}}}
```

## PUT /plugins/{plugin\_id}/actions

> make an action on a plugin

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Plugins","description":"Operations related to **Plugins**, the extensible web service components hosted by the platform that add custom functionality. Plugin types include:\n- **Activity Analyzers** (enrich tracking data)\n- **Audience Segment External Feeds** (sync segments to partners)\n- **Display Ad Renderers** (customize ad rendering)\n- **Email Renderers** (customize email rendering)\n- **Email Routers** (manage email sending)\n- **Attribution Engines** (custom attribution)\n- **Custom Actions** (automation actions)\n- **ML Algorithms** (predictions)\n- **Computed Fields** (calculated schema fields)\n\nRelevant documentation:\n- [Plugins](https://developer.mediarithmics.io/advanced-usages/plugins)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/plugins/{plugin_id}/actions":{"put":{"requestBody":{"description":"The action to make","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PluginActionResource"}}},"required":true},"summary":"make an action on a plugin","parameters":[{"explode":false,"style":"simple","required":true,"schema":{"type":"string"},"in":"path","description":"ID of the plugin","name":"plugin_id"}],"operationId":"makePluginAction","description":"","tags":["Plugins"],"responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/PluginResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}}}}},"components":{"schemas":{"PluginActionResource":{"discriminator":{"propertyName":"type","mapping":{"ARCHIVE_PLUGIN":"#/components/schemas/ArchivePluginResource","UNARCHIVE_PLUGIN":"#/components/schemas/UnarchivePluginResource"}},"oneOf":[{"$ref":"#/components/schemas/ArchivePluginResource"},{"$ref":"#/components/schemas/UnarchivePluginResource"}],"properties":{"type":{"type":"string","enum":["ARCHIVE_PLUGIN","UNARCHIVE_PLUGIN"]}},"required":["type"]},"ArchivePluginResource":{"type":"object","properties":{"plugin_id":{"type":"string","readOnly":false}},"required":["plugin_id"]},"UnarchivePluginResource":{"type":"object","properties":{"plugin_id":{"type":"string","readOnly":false}},"required":["plugin_id"]},"PluginResource":{"type":"object","properties":{"plugin_type":{"$ref":"#/components/schemas/PluginType"},"group_id":{"type":"string","readOnly":false},"organisation_id":{"type":"string","readOnly":false},"artifact_id":{"type":"string","readOnly":false},"archived":{"type":"boolean","default":false,"readOnly":true},"current_version_id":{"type":"string","readOnly":true},"id":{"type":"string","readOnly":true}},"required":["archived","artifact_id","group_id","id","organisation_id","plugin_type"]},"PluginType":{"type":"string","enum":["DISPLAY_CAMPAIGN_EDITOR","EMAIL_CAMPAIGN_EDITOR","EMAIL_TEMPLATE_EDITOR","EMAIL_TEMPLATE_RENDERER","EMAIL_ROUTER","DISPLAY_AD_EDITOR","DISPLAY_AD_RENDERER","RECOMMENDER","VIDEO_AD_EDITOR","VIDEO_AD_RENDERER","STYLE_SHEET","AUDIENCE_SEGMENT_EXTERNAL_FEED","AUDIENCE_SEGMENT_TAG_FEED","BID_OPTIMIZATION_ENGINE","ATTRIBUTION_PROCESSOR","ACTIVITY_ANALYZER","DATA_CONNECTOR","SCENARIO_NODE_PROCESSOR","ML_FUNCTION","DATAMART_FUNCTION","COMPUTED_FIELD_FUNCTION","INTEGRATION_BATCH","SCENARIO_CUSTOM_ACTION","CONTEXTUAL_LIST_TAG_FEED"],"readOnly":false},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## POST /plugins/{plugin\_id}/versions/{plugin\_version\_id}/actions

> make an action on a plugin version

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Plugins","description":"Operations related to **Plugins**, the extensible web service components hosted by the platform that add custom functionality. Plugin types include:\n- **Activity Analyzers** (enrich tracking data)\n- **Audience Segment External Feeds** (sync segments to partners)\n- **Display Ad Renderers** (customize ad rendering)\n- **Email Renderers** (customize email rendering)\n- **Email Routers** (manage email sending)\n- **Attribution Engines** (custom attribution)\n- **Custom Actions** (automation actions)\n- **ML Algorithms** (predictions)\n- **Computed Fields** (calculated schema fields)\n\nRelevant documentation:\n- [Plugins](https://developer.mediarithmics.io/advanced-usages/plugins)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/plugins/{plugin_id}/versions/{plugin_version_id}/actions":{"post":{"parameters":[{"required":true,"style":"simple","schema":{"type":"string"},"description":"ID of the plugin","name":"plugin_id","explode":false,"in":"path"},{"in":"path","name":"plugin_version_id","style":"simple","description":"ID of the plugin version","explode":false,"required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/PluginVersionResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"description":"","tags":["Plugins"],"requestBody":{"description":"The action to make","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PluginVersionActionResource"}}},"required":true},"summary":"make an action on a plugin version","operationId":"makePluginVersionAction"}}},"components":{"schemas":{"PluginVersionResource":{"type":"object","properties":{"version_id":{"type":"string","readOnly":false},"features":{"type":"array","items":{"$ref":"#/components/schemas/PluginVersionFeature"},"readOnly":true},"id":{"type":"string","readOnly":true},"organisation_id":{"type":"string","readOnly":true},"artifact_id":{"type":"string","readOnly":true},"archived":{"type":"boolean","default":false,"readOnly":false},"image_name":{"type":"string","readOnly":true},"tenant_credentials_scheme":{"$ref":"#/components/schemas/TenantCredentialsScheme"},"script_path":{"type":"string","readOnly":false},"build_tag":{"type":"string","readOnly":true},"group_id":{"type":"string","readOnly":true},"file_delivery_activated":{"type":"boolean","default":false,"readOnly":false},"identifying_resources_locked":{"type":"boolean","default":false,"readOnly":true},"maintainer_id":{"type":"string","readOnly":true},"authenticate_at_instantiation":{"type":"boolean","default":false,"readOnly":false},"status":{"$ref":"#/components/schemas/PluginVersionStatus"},"engine_type":{"$ref":"#/components/schemas/PluginEngineType"},"plugin_type":{"$ref":"#/components/schemas/PluginType"},"plugin_id":{"type":"string","readOnly":false}},"required":["archived","artifact_id","authenticate_at_instantiation","features","file_delivery_activated","group_id","id","identifying_resources_locked","organisation_id","plugin_id","plugin_type","script_path","status","version_id"]},"PluginVersionFeature":{"type":"string","enum":["CLEANING_AND_DELETION"],"readOnly":false},"TenantCredentialsScheme":{"type":"string","enum":["GOOGLE_SERVICE_ACCOUNT","NO_CREDENTIALS","JDBC_CREDENTIALS","SNOWFLAKE","HMAC","S3","OAUTH2","API_TOKEN","LOGIN_PASSWORD"],"readOnly":false},"PluginVersionStatus":{"type":"string","enum":["DRAFT","DEPLOYING","TESTING","LIVE","DECOMMISSIONED"],"readOnly":false},"PluginEngineType":{"type":"string","enum":["NATIVE","HOSTED_CONTAINERS","HOSTED_SCRIPT","BROWSER"],"readOnly":false},"PluginType":{"type":"string","enum":["DISPLAY_CAMPAIGN_EDITOR","EMAIL_CAMPAIGN_EDITOR","EMAIL_TEMPLATE_EDITOR","EMAIL_TEMPLATE_RENDERER","EMAIL_ROUTER","DISPLAY_AD_EDITOR","DISPLAY_AD_RENDERER","RECOMMENDER","VIDEO_AD_EDITOR","VIDEO_AD_RENDERER","STYLE_SHEET","AUDIENCE_SEGMENT_EXTERNAL_FEED","AUDIENCE_SEGMENT_TAG_FEED","BID_OPTIMIZATION_ENGINE","ATTRIBUTION_PROCESSOR","ACTIVITY_ANALYZER","DATA_CONNECTOR","SCENARIO_NODE_PROCESSOR","ML_FUNCTION","DATAMART_FUNCTION","COMPUTED_FIELD_FUNCTION","INTEGRATION_BATCH","SCENARIO_CUSTOM_ACTION","CONTEXTUAL_LIST_TAG_FEED"],"readOnly":false},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]},"PluginVersionActionResource":{"discriminator":{"propertyName":"type","mapping":{"ARCHIVE_VERSION":"#/components/schemas/ArchivePluginVersionResource","DEPLOY_PLUGIN":"#/components/schemas/DeployPluginVersionResource","UPGRADE_ALL_CONTAINERS":"#/components/schemas/UpgradeAllContainersPluginVersionResource","UPDATE_IDENTIFYING_RESOURCES_LOCK":"#/components/schemas/UpdateIdentifyingResourcesLockActionResource","PROMOTE_TO_CURRENT_VERSION":"#/components/schemas/PromoteToCurrentVersionActionResource","DECOMMISSION_VERSION":"#/components/schemas/DecommissionVersionActionResource","UPGRADE_PLUGIN_INSTANCES":"#/components/schemas/UpgradePluginInstancesResource","PUBLISH_LIVE_VERSION":"#/components/schemas/PublishLiveVersionActionResource","UPDATE_CREDENTIALS_SCHEME":"#/components/schemas/UpdateCredentialsSchemeActionResource"}},"oneOf":[{"$ref":"#/components/schemas/PublishLiveVersionActionResource"},{"$ref":"#/components/schemas/ArchivePluginVersionResource"},{"$ref":"#/components/schemas/DeployPluginVersionResource"},{"$ref":"#/components/schemas/DecommissionVersionActionResource"},{"$ref":"#/components/schemas/UpgradeAllContainersPluginVersionResource"},{"$ref":"#/components/schemas/UpdateCredentialsSchemeActionResource"},{"$ref":"#/components/schemas/PromoteToCurrentVersionActionResource"},{"$ref":"#/components/schemas/UpgradePluginInstancesResource"},{"$ref":"#/components/schemas/UpdateIdentifyingResourcesLockActionResource"}],"properties":{"type":{"type":"string","enum":["PUBLISH_LIVE_VERSION","ARCHIVE_VERSION","DEPLOY_PLUGIN","DECOMMISSION_VERSION","UPGRADE_ALL_CONTAINERS","UPDATE_CREDENTIALS_SCHEME","PROMOTE_TO_CURRENT_VERSION","UPGRADE_PLUGIN_INSTANCES","UPDATE_IDENTIFYING_RESOURCES_LOCK"]}},"required":["type"]},"PublishLiveVersionActionResource":{"type":"object","properties":{"plugin_version_id":{"type":"string","readOnly":false},"plugin_id":{"type":"string","readOnly":false}},"required":["plugin_id","plugin_version_id"]},"ArchivePluginVersionResource":{"type":"object","properties":{"plugin_version_id":{"type":"string","readOnly":false},"plugin_id":{"type":"string","readOnly":false}},"required":["plugin_id","plugin_version_id"]},"DeployPluginVersionResource":{"type":"object","properties":{"plugin_version_id":{"type":"string","readOnly":false},"plugin_id":{"type":"string","readOnly":false},"target_build_tag":{"type":"string","readOnly":false}},"required":["plugin_id","plugin_version_id","target_build_tag"]},"DecommissionVersionActionResource":{"type":"object","properties":{"plugin_version_id":{"type":"string","readOnly":false},"plugin_id":{"type":"string","readOnly":false}},"required":["plugin_id","plugin_version_id"]},"UpgradeAllContainersPluginVersionResource":{"type":"object","properties":{"plugin_version_id":{"type":"string","readOnly":false},"plugin_id":{"type":"string","readOnly":false},"target_build_tag":{"type":"string","readOnly":false}},"required":["plugin_id","plugin_version_id","target_build_tag"]},"UpdateCredentialsSchemeActionResource":{"type":"object","properties":{"plugin_version_id":{"type":"string","readOnly":false},"plugin_id":{"type":"string","readOnly":false},"credentials_scheme":{"$ref":"#/components/schemas/TenantCredentialsScheme"}},"required":["credentials_scheme","plugin_id","plugin_version_id"]},"PromoteToCurrentVersionActionResource":{"type":"object","properties":{"plugin_version_id":{"type":"string","readOnly":false},"plugin_id":{"type":"string","readOnly":false}},"required":["plugin_id","plugin_version_id"]},"UpgradePluginInstancesResource":{"type":"object","properties":{"selected_identifying_resource_overrides":{"type":"array","items":{"$ref":"#/components/schemas/PluginCompatibleIdentifyingResourceResource"},"readOnly":false},"plugin_version_id":{"type":"string","readOnly":false},"property_resource_overrides":{"type":"array","items":{"$ref":"#/components/schemas/PropertyResource"},"readOnly":false},"plugin_id":{"type":"string","readOnly":false},"plugin_preset_id":{"type":"string","readOnly":false},"instances":{"$ref":"#/components/schemas/PluginInstances"}},"required":["instances","plugin_id","plugin_preset_id","plugin_version_id","property_resource_overrides","selected_identifying_resource_overrides"]},"PluginCompatibleIdentifyingResourceResource":{"discriminator":{"propertyName":"type","mapping":{"USER_ACCOUNT":"#/components/schemas/PluginCompatibleIdentifyingAccountResource","USER_EMAIL":"#/components/schemas/PluginCompatibleIdentifyingEmailResource","USER_DEVICE_TECHNICAL_ID":"#/components/schemas/PluginCompatibleIdentifyingDeviceTechnicalIdResource","USER_PROFILE":"#/components/schemas/PluginCompatibleIdentifyingProfileResource"}},"oneOf":[{"$ref":"#/components/schemas/PluginCompatibleIdentifyingAccountResource"},{"$ref":"#/components/schemas/PluginCompatibleIdentifyingEmailResource"},{"$ref":"#/components/schemas/PluginCompatibleIdentifyingDeviceTechnicalIdResource"},{"$ref":"#/components/schemas/PluginCompatibleIdentifyingProfileResource"}],"properties":{"type":{"type":"string","enum":["USER_ACCOUNT","USER_EMAIL","USER_DEVICE_TECHNICAL_ID","USER_PROFILE"]}},"required":["type"]},"PluginCompatibleIdentifyingAccountResource":{"type":"object","properties":{"created_by":{"type":"string","readOnly":true},"last_modified_by":{"type":"string","readOnly":true},"plugin_id":{"type":"string","readOnly":true},"plugin_version_id":{"type":"string","readOnly":true},"id":{"type":"string","readOnly":true},"last_modified_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"compartment_type":{"$ref":"#/components/schemas/UserAccountCompartmentType"},"created_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"identity_graph_id":{"type":"string","readOnly":false},"compartment_id":{"type":"string","readOnly":false}},"required":["compartment_type","created_by","created_ts","id","plugin_id","plugin_version_id"]},"UserAccountCompartmentType":{"type":"string","enum":["CUSTOM_COMPARTMENT_ID","NETWORK_USER_ID"],"readOnly":false},"PluginCompatibleIdentifyingEmailResource":{"type":"object","properties":{"id":{"type":"string","readOnly":true},"last_modified_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"last_modified_by":{"type":"string","readOnly":true},"created_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"created_by":{"type":"string","readOnly":true},"plugin_id":{"type":"string","readOnly":true},"plugin_version_id":{"type":"string","readOnly":true},"identity_graph_id":{"type":"string","readOnly":false}},"required":["created_by","created_ts","id","plugin_id","plugin_version_id"]},"PluginCompatibleIdentifyingDeviceTechnicalIdResource":{"type":"object","properties":{"id":{"type":"string","readOnly":true},"created_by":{"type":"string","readOnly":true},"last_modified_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"registry_id":{"type":"string","readOnly":false},"registry_type":{"$ref":"#/components/schemas/DeviceIdRegistryType"},"identity_graph_id":{"type":"string","readOnly":false},"plugin_id":{"type":"string","readOnly":true},"plugin_version_id":{"type":"string","readOnly":true},"last_modified_by":{"type":"string","readOnly":true},"created_ts":{"type":"integer","format":"int64","default":0,"readOnly":true}},"required":["created_by","created_ts","id","plugin_id","plugin_version_id","registry_type"]},"DeviceIdRegistryType":{"type":"string","enum":["INSTALLATION_ID","MUM_ID","NETWORK_DEVICE_ID","CUSTOM_DEVICE_ID","MOBILE_ADVERTISING_ID","MOBILE_VENDOR_ID","TV_ADVERTISING_ID","IP_V4_ADDRESS_ID","IP_V6_ADDRESS_ID"],"readOnly":false},"PluginCompatibleIdentifyingProfileResource":{"type":"object","properties":{"created_by":{"type":"string","readOnly":true},"plugin_version_id":{"type":"string","readOnly":true},"plugin_id":{"type":"string","readOnly":true},"include_in_platform_calls":{"type":"boolean","default":false,"readOnly":false},"id":{"type":"string","readOnly":true},"created_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"compartment_id":{"type":"string","readOnly":false},"last_modified_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"identity_graph_id":{"type":"string","readOnly":false},"last_modified_by":{"type":"string","readOnly":true}},"required":["created_by","created_ts","id","include_in_platform_calls","plugin_id","plugin_version_id"]},"PropertyResource":{"type":"object","properties":{"writable":{"type":"boolean","default":false,"readOnly":false},"value":{"$ref":"#/components/schemas/PropertyValueResource"},"origin":{"$ref":"#/components/schemas/PluginPropertyOrigin"},"technical_name":{"type":"string","readOnly":false},"deletable":{"type":"boolean","default":false,"readOnly":false}},"required":["deletable","origin","technical_name","value","writable"]},"PropertyValueResource":{"type":"object"},"PluginPropertyOrigin":{"type":"string","enum":["PLUGIN_STATIC","PLUGIN","INSTANCE"],"readOnly":false},"PluginInstances":{"discriminator":{"propertyName":"type","mapping":{"AUDIENCE_SEGMENT_EXTERNAL_FEEDS":"#/components/schemas/AudienceSegmentExternalFeedInstancesResource"}},"oneOf":[{"$ref":"#/components/schemas/AudienceSegmentExternalFeedInstancesResource"}],"properties":{"type":{"type":"string","enum":["AUDIENCE_SEGMENT_EXTERNAL_FEEDS"]}},"required":["type"]},"AudienceSegmentExternalFeedInstancesResource":{"type":"object","properties":{"instances":{"type":"array","items":{"$ref":"#/components/schemas/AudienceSegmentExternalFeedInstanceResource"},"readOnly":false}},"required":["instances"]},"AudienceSegmentExternalFeedInstanceResource":{"type":"object","properties":{"audience_segment_id":{"format":"int64","readOnly":false,"type":"integer","default":0},"external_feed_id":{"format":"int64","type":"integer","default":0,"readOnly":false}},"required":["audience_segment_id","external_feed_id"]},"UpdateIdentifyingResourcesLockActionResource":{"type":"object","properties":{"plugin_version_id":{"type":"string","readOnly":false},"plugin_id":{"type":"string","readOnly":false},"identifying_resources_locked":{"type":"boolean","default":false,"readOnly":false}},"required":["identifying_resources_locked","plugin_id","plugin_version_id"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## POST /plugins/{plugin\_id}/versions/{plugin\_version\_id}/dynamic\_property\_values\_queries

> Fetch available dynamic property values from the plugin connector

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Plugins","description":"Operations related to **Plugins**, the extensible web service components hosted by the platform that add custom functionality. Plugin types include:\n- **Activity Analyzers** (enrich tracking data)\n- **Audience Segment External Feeds** (sync segments to partners)\n- **Display Ad Renderers** (customize ad rendering)\n- **Email Renderers** (customize email rendering)\n- **Email Routers** (manage email sending)\n- **Attribution Engines** (custom attribution)\n- **Custom Actions** (automation actions)\n- **ML Algorithms** (predictions)\n- **Computed Fields** (calculated schema fields)\n\nRelevant documentation:\n- [Plugins](https://developer.mediarithmics.io/advanced-usages/plugins)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/plugins/{plugin_id}/versions/{plugin_version_id}/dynamic_property_values_queries":{"post":{"tags":["Plugins"],"operationId":"queryPluginVersionDynamicPropertyValues","summary":"Fetch available dynamic property values from the plugin connector","responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/ExternalFeedDynamicPropertyValuesQueryResponse"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"description":"","parameters":[{"schema":{"type":"string"},"description":"ID of the plugin","required":true,"in":"path","explode":false,"name":"plugin_id","style":"simple"},{"required":true,"style":"simple","explode":false,"name":"plugin_version_id","in":"path","schema":{"type":"string"},"description":"ID of the plugin version"}],"requestBody":{"description":"Query resource with known properties as context","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PluginVersionDynamicPropertyValuesQueryResource"}}},"required":true}}}},"components":{"schemas":{"ExternalFeedDynamicPropertyValuesQueryResponse":{"type":"object","properties":{"status":{"$ref":"#/components/schemas/ExternalFeedDynamicPropertyValuesQueryStatus"},"message":{"type":"string","readOnly":false},"data":{"type":"array","items":{"$ref":"#/components/schemas/PluginLayoutPropertyValuesResource"},"readOnly":false},"count":{"type":"integer","format":"int32","default":0,"readOnly":false}},"required":["status"]},"ExternalFeedDynamicPropertyValuesQueryStatus":{"type":"string","enum":["ok","error","empty","not_implemented"],"readOnly":false},"PluginLayoutPropertyValuesResource":{"allOf":[{"$ref":"#/components/schemas/AbstractPluginLayoutPropertyValues"},{"type":"object","properties":{"property_technical_name":{"type":"string","readOnly":false},"enum":{"type":"array","items":{"$ref":"#/components/schemas/PluginLayoutEnumResource"},"readOnly":false}},"required":["property_technical_name"]}]},"AbstractPluginLayoutPropertyValues":{"type":"object"},"PluginLayoutEnumResource":{"type":"object","properties":{"value":{"type":"string","readOnly":false},"label":{"type":"string","readOnly":false}},"required":["label","value"]},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]},"PluginVersionDynamicPropertyValuesQueryResource":{"type":"object","properties":{"properties":{"type":"array","items":{"$ref":"#/components/schemas/PropertyResource"},"readOnly":false},"datamart_id":{"type":"string","readOnly":false},"feed_destination_id":{"type":"string","readOnly":false}},"required":["datamart_id","properties"]},"PropertyResource":{"type":"object","properties":{"writable":{"type":"boolean","default":false,"readOnly":false},"value":{"$ref":"#/components/schemas/PropertyValueResource"},"origin":{"$ref":"#/components/schemas/PluginPropertyOrigin"},"technical_name":{"type":"string","readOnly":false},"deletable":{"type":"boolean","default":false,"readOnly":false}},"required":["deletable","origin","technical_name","value","writable"]},"PropertyValueResource":{"type":"object"},"PluginPropertyOrigin":{"type":"string","enum":["PLUGIN_STATIC","PLUGIN","INSTANCE"],"readOnly":false}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## GET /plugins/{plugin\_id}/versions/{version\_id}/containers

> Find all running plugin containers grouped by plugin-manager based on a plugin version

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Plugins","description":"Operations related to **Plugins**, the extensible web service components hosted by the platform that add custom functionality. Plugin types include:\n- **Activity Analyzers** (enrich tracking data)\n- **Audience Segment External Feeds** (sync segments to partners)\n- **Display Ad Renderers** (customize ad rendering)\n- **Email Renderers** (customize email rendering)\n- **Email Routers** (manage email sending)\n- **Attribution Engines** (custom attribution)\n- **Custom Actions** (automation actions)\n- **ML Algorithms** (predictions)\n- **Computed Fields** (calculated schema fields)\n\nRelevant documentation:\n- [Plugins](https://developer.mediarithmics.io/advanced-usages/plugins)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/plugins/{plugin_id}/versions/{version_id}/containers":{"get":{"summary":"Find all running plugin containers grouped by plugin-manager based on a plugin version","parameters":[{"in":"query","explode":true,"name":"organisation_id","style":"form","description":"The organisation in which the search is performed","schema":{"type":"integer","format":"int64"},"required":true},{"explode":false,"in":"path","description":"The plugin id","style":"simple","required":true,"schema":{"type":"integer","format":"int64"},"name":"plugin_id"},{"name":"version_id","description":"The plugin version id","schema":{"type":"integer","format":"int64"},"explode":false,"style":"simple","required":true,"in":"path"},{"required":false,"description":"Offset from which the search must be performed","in":"query","name":"first_result","style":"form","schema":{"type":"integer","format":"int32"},"explode":true},{"schema":{"type":"integer","format":"int32"},"description":"Number of maximum items that shall be return by this search","explode":true,"style":"form","in":"query","name":"max_results","required":false}],"description":"","tags":["Plugins"],"operationId":"getAllRunningContainersByPluginVersion","responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/PluginManagerResource"}},"max_results":{"type":"integer"},"first_result":{"type":"integer"},"status":{"type":"string","enum":["ok"]},"count":{"type":"integer"},"total":{"type":"integer"}},"required":["count","data","first_result","max_results","status","total"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}}}}},"components":{"schemas":{"PluginManagerResource":{"type":"object","properties":{"name":{"type":"string","readOnly":false},"running_containers":{"type":"array","items":{"$ref":"#/components/schemas/RunningContainerResource"},"readOnly":false}},"required":["name","running_containers"]},"RunningContainerResource":{"type":"object","properties":{"container":{"type":"string","readOnly":false}},"required":["container"]},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## GET /audience\_segments/{segment\_id}/available\_plugins

> Search accessible plugins for the segment

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Plugins","description":"Operations related to **Plugins**, the extensible web service components hosted by the platform that add custom functionality. Plugin types include:\n- **Activity Analyzers** (enrich tracking data)\n- **Audience Segment External Feeds** (sync segments to partners)\n- **Display Ad Renderers** (customize ad rendering)\n- **Email Renderers** (customize email rendering)\n- **Email Routers** (manage email sending)\n- **Attribution Engines** (custom attribution)\n- **Custom Actions** (automation actions)\n- **ML Algorithms** (predictions)\n- **Computed Fields** (calculated schema fields)\n\nRelevant documentation:\n- [Plugins](https://developer.mediarithmics.io/advanced-usages/plugins)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/audience_segments/{segment_id}/available_plugins":{"get":{"parameters":[{"description":"The segment id","style":"simple","required":true,"schema":{"type":"integer","format":"int64"},"name":"segment_id","in":"path","explode":false},{"name":"plugin_type","style":"form","description":"The type of plugins","schema":{"$ref":"#/components/schemas/PluginType"},"required":false,"in":"query","explode":true},{"explode":true,"in":"query","description":"Artifact id","required":false,"name":"artifact_id","style":"form","schema":{"type":"integer","format":"int64"}},{"explode":true,"required":false,"name":"group_id","in":"query","description":"Group id","style":"form","schema":{"type":"integer","format":"int64"}},{"name":"organisation_id","required":false,"style":"form","in":"query","explode":true,"description":"Organisation id","schema":{"type":"integer","format":"int64"}},{"schema":{"type":"array","items":{"type":"integer","format":"int64"}},"required":false,"in":"query","description":"List of organisation Ids we want to query","style":"form","explode":true,"name":"organisation_ids"},{"schema":{"type":"array","items":{"type":"string"}},"name":"order_by","explode":true,"style":"form","in":"query","description":"Fields used to order the result","required":false},{"description":"Can be used to search elements","explode":true,"required":false,"in":"query","style":"form","name":"keywords","schema":{"type":"string"}},{"description":"Current version statuses","explode":true,"style":"form","in":"query","required":false,"schema":{"type":"array","items":{"type":"string"}},"name":"current_version_statuses"},{"required":false,"style":"form","schema":{"type":"boolean"},"name":"archived","description":"If true the result will contain only archived dashboards","in":"query","explode":true},{"description":"Offset from which the search must be performed","in":"query","name":"first_result","schema":{"type":"integer","format":"int32"},"explode":true,"style":"form","required":false},{"description":"Number of maximum items that shall be return by this search","style":"form","in":"query","schema":{"type":"integer","format":"int32"},"explode":true,"required":false,"name":"max_results"}],"tags":["Plugins"],"operationId":"findAudienceSegmentPlugins","responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"first_result":{"type":"integer"},"data":{"type":"array","items":{"$ref":"#/components/schemas/PluginResource"}},"count":{"type":"integer"},"max_results":{"type":"integer"},"total":{"type":"integer"}},"required":["count","data","first_result","max_results","status","total"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"summary":"Search accessible plugins for the segment","description":""}}},"components":{"schemas":{"PluginType":{"type":"string","enum":["DISPLAY_CAMPAIGN_EDITOR","EMAIL_CAMPAIGN_EDITOR","EMAIL_TEMPLATE_EDITOR","EMAIL_TEMPLATE_RENDERER","EMAIL_ROUTER","DISPLAY_AD_EDITOR","DISPLAY_AD_RENDERER","RECOMMENDER","VIDEO_AD_EDITOR","VIDEO_AD_RENDERER","STYLE_SHEET","AUDIENCE_SEGMENT_EXTERNAL_FEED","AUDIENCE_SEGMENT_TAG_FEED","BID_OPTIMIZATION_ENGINE","ATTRIBUTION_PROCESSOR","ACTIVITY_ANALYZER","DATA_CONNECTOR","SCENARIO_NODE_PROCESSOR","ML_FUNCTION","DATAMART_FUNCTION","COMPUTED_FIELD_FUNCTION","INTEGRATION_BATCH","SCENARIO_CUSTOM_ACTION","CONTEXTUAL_LIST_TAG_FEED"],"readOnly":false},"PluginResource":{"type":"object","properties":{"plugin_type":{"$ref":"#/components/schemas/PluginType"},"group_id":{"type":"string","readOnly":false},"organisation_id":{"type":"string","readOnly":false},"artifact_id":{"type":"string","readOnly":false},"archived":{"type":"boolean","default":false,"readOnly":true},"current_version_id":{"type":"string","readOnly":true},"id":{"type":"string","readOnly":true}},"required":["archived","artifact_id","group_id","id","organisation_id","plugin_type"]},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.mediarithmics.io/api-reference/plugin/plugins.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
